#ifdef _MSC_VER
  #ifdef _DEBUG
    // detect Memory-Leaks
    #include <crtdbg.h>
    #define _CRTDBG_MAP_ALLOC
  #endif
#endif
#ifdef _DEBUG_MEMORY_SPY
  #include <MilDebugNew.h>
  #include "MemoryLeakIndicator.h"
#endif
#include "IniFile.h"
#include "EuException.h"
#include <iostream>

#if defined(_MSC_VER) || defined(__MINGW32__)
  #include <conio.h>
#elif defined(__GNUC__)
  #include <unistd.h>
  #include <termios.h>
  #include <stdio.h>
  #include <string.h>
  #include <limits.h>
  #define _MAX_PATH PATH_MAX
  //---------------------------------------------------------------------------
  int _getche()
  {
    char            ch = 0;
    struct termios  tOld;

    fflush( stdout );
    if ( tcgetattr( 0, & tOld ) < 0 )
    {
      perror("tcgetattr");
    }
    tOld.c_lflag &= ~ICANON;
    tOld.c_lflag &= ~ECHO;
    tOld.c_cc[VMIN] = 1;
    tOld.c_cc[VTIME] = 0;
    if ( tcsetattr( 0, TCSANOW, & tOld ) < 0 )
    {
      perror("tcsetattr ICANON");
    }
    if ( read( 0, & ch, 1 ) < 0 )
    {
      perror("read");
    }
    tOld.c_lflag |= ICANON;
    tOld.c_lflag |= ECHO;
    if ( tcsetattr( 0, TCSADRAIN, & tOld ) < 0 )
    {
      perror("tcsetattr ~ICANON");
    }
    return ch;
    }
  //---------------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------------
#if defined(__MINGW32__) || defined(__GNUC__)
  // Warnung: unused parameter 'argc'
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wunused-parameter"
#endif
//-----------------------------------------------------------------------------
#ifdef _MSC_VER
  // 'SUPER': Unreferenzierter formaler Parameter
  #pragma warning( disable : 4100 )
#endif
//----------------------------------------------------------------------------
int main(int argc, char *argv[])
{
  #ifdef _DEBUG
    int i = 0;
    for (;i < argc;++i)
    {
      std::cout << "Arg["  << i << "]: " << argv[i] << "\n!";
    }
  #endif // _DEBUG
  #ifdef _MSC_VER
    // Zeigt Speicherleaks an, wenn welche da...
    _CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
    // Nächste Zeile mit Zahl aus { } ({56} normal block at 0x00D01C78, 10 bytes long.) rein
    //_crtBreakAlloc = 1149;
  #endif
  #ifdef _DEBUG_MEMORY_SPY
    MemSpy::LeakMap * t_pLeakMap = MemSpy::LeakMap::create();;
  #endif
  
  int          t_iErr = 0;
  ini::File * t_pIniFile = NULL_PTR;
  //--------------------------------------------------------------------------
  ///*
  // New Ini-File "test.ini"
  try
  {
    t_pIniFile = new ini::File( "test.ini", ini::bCreateInifile );
  }
  catch( eut::ErrorNException & ERR )
  {
    std::cout << "Error :" << ERR.what() <<  "ErrNo.:" << ERR.error() << std::endl;
    return ERR.error();
  }
  // new sections with new keys
  if ( ! t_iErr ) t_iErr = t_pIniFile->setKeyValue( "[Section 1]", "Key 1.1", "Value 1.1" );
  if ( ! t_iErr ) t_iErr = t_pIniFile->setKeyValue( "[Section 1]", "Key 1.2", "Value 1.2" );
  if ( ! t_iErr ) t_iErr = t_pIniFile->setKeyValue( "[Section 2]", "Key 2.1", "Value 2.1" );
  if ( ! t_iErr ) t_iErr = t_pIniFile->setKeyValue( "[Section 2]", "Key 2.2", "Value 2.2" );
  // a comment
  ini::Line  *  t_pCommentLine = NULL_PTR;
  try
  {
    t_pCommentLine = new ini::Line( "; comment 1" );
  }
  catch( eut::ErrorNException & ERR )
  {
    std::cout << "Error :" << ERR.what() <<  "ErrNo.:" << ERR.error() << std::endl;
    t_iErr = ERR.error();
  }
  if ( ! t_iErr )
  {
    t_iErr = t_pIniFile->insertLine( t_pCommentLine );
  }

  // a lonly key
  if ( ! t_iErr ) t_iErr = t_pIniFile->setKeyValue( "", "Lonly Key 1", "Value 1" );
  // and store the Ini-File
  if ( ! t_iErr ) t_iErr = t_pIniFile->store();
  delete t_pIniFile; t_pIniFile = 0;
  //*/
  //--------------------------------------------------------------------------
  ///*
  // show and change a key in test.ini
  try
  {
    t_pIniFile = new ini::File( "test.ini", ini::bOpenInifile );
  }
  catch( eut::ErrorNException & ERR )
  {
    std::cout << "Error :" << ERR.what() <<  "ErrNo.:" << ERR.error() << std::endl;
    return ERR.error();
  }
  // get the value from "Section 1", "Key 1.2"
  std::string t_sValue,
              t_sSection2( "[Section 1]" ),
              t_sKey( "Key 1.2" );

  t_iErr = t_pIniFile->getKeyValue( t_sValue, & t_sSection2, & t_sKey );
  if ( ! t_iErr )
  {
    std::cout << "The value from 'Section 1', 'Key 1.2' is: " << t_sValue << std::endl;
    t_iErr = t_pIniFile->setKeyValue( "[Section 1]", "Key 1.2", "new Value" );
  }
  if ( ! t_iErr ) t_iErr = t_pIniFile->store();
  delete t_pIniFile; t_pIniFile = 0;
  //*/
  //--------------------------------------------------------------------------
  ///*
  // show complete test.ini
  try
  {
    t_pIniFile = new ini::File( "test.ini", ini::bOpenInifile );
  }
  catch( eut::ErrorNException & ERR )
  {
    std::cout << "Error :" << ERR.what() <<  "ErrNo.:" << ERR.error() << std::endl;
    return ERR.error();
  }
  ini::Line  *  t_pShowLine = NULL_PTR;

  std::cout << "############# " << t_pIniFile->getFileName() << " #############" << std::endl;
  t_iErr = t_pIniFile->getLine( t_pShowLine, 0, ptl::START );
  while ( t_pShowLine )
  {
    std::cout << t_pShowLine->getText() << std::endl;
    // if section, show sectionlines
    if ( t_pShowLine->getType() == ini::LINE_TYPE::IniSECTION )
    {
      ini::Section  * t_pCastSectionLine = dynamic_cast<ini::Section*>(t_pShowLine);
      
      if ( t_pCastSectionLine )
      {
        ini::Line * t_pShowSectionLine = NULL_PTR;

        t_iErr = t_pCastSectionLine->getSectionLine( t_pShowSectionLine, 0, ptl::START );
        while ( t_pShowSectionLine )
        {
          std::cout << t_pShowSectionLine->getText() << std::endl;
          t_iErr = t_pCastSectionLine->getSectionLine( t_pShowSectionLine, 1, ptl::CURRENT );
        }
        t_iErr = ( t_iErr == eut::ERR_RANGE ? 0 : t_iErr );
      }
    }
    t_iErr = t_pIniFile->getLine( t_pShowLine, 1, ptl::CURRENT );
  }
  t_iErr = ( t_iErr == ptl::RANGE ? 0 : t_iErr );
  std::cout << "####################################" << std::endl;
  std::cout << "ErrNo.:" << t_iErr << std::endl;
  delete t_pIniFile; t_pIniFile = NULL_PTR;
  //*/
  //--------------------------------------------------------------------------
  ///*
  // show all IniLine's in Section [Section 2] test.ini
  try
  {
    t_pIniFile = new ini::File( "test.ini", ini::bOpenInifile );
  }
  catch( eut::ErrorNException & ERR )
  {
    std::cout << "Error :" << ERR.what() <<  "ErrNo.:" << ERR.error() << std::endl;
    return ERR.error();
  }
  ini::Line   * t_pIniLineSec = NULL_PTR;
  std::string   t_sSection1( "[Section 2]" );

  t_iErr = t_pIniFile->getLine( t_pIniLineSec, & t_sSection1 );
  if ( ! t_iErr )
  {
    ini::Section  * t_pIniSection = dynamic_cast<ini::Section*> ( t_pIniLineSec );
    if ( t_pIniSection )
    {
      std::cout << t_pIniSection->getText() << std::endl;
      ini::Line   * t_pIniLine = NULL_PTR;
      t_iErr = t_pIniSection->getSectionLine( t_pIniLine, 0, ptl::START );
      if ( ! t_iErr )
      {
        do
        {
          std::cout << t_pIniLine->getText() << std::endl;
          t_iErr = t_pIniSection->getSectionLine( t_pIniLine, 1, ptl::CURRENT );
        } while ( ! t_iErr );
      }
    }
  }

  delete t_pIniFile; t_pIniFile = NULL_PTR;
  //*/
  #ifdef _DEBUG_MEMORY_SPY
    // Speicherleaks anzeigen lassen
    if ( t_pLeakMap->sizeOfObjectList() )
    {
      MemSpy::LeakMap::MemoryItem  * t_pMemoryItem = t_pLeakMap->getSpyObject( MemSpy::START );
      if ( t_pMemoryItem )
      {
         do
         {
            printf("Memory leak detected in %p, created in file %s at line %d\n", (void*)t_pMemoryItem->m_pItemPtr, t_pMemoryItem->m_FileName, t_pMemoryItem->m_iLineNumber);
            t_pMemoryItem = t_pLeakMap->getSpyObject( MemSpy::NEXT );
         } while ( t_pMemoryItem );
      }
    }
    MemSpy::LeakMap::destroyAbsolutely();
  #endif
  std::cout << "Press a key" << std::endl;
  _getch();
  return t_iErr;
}
//-----------------------------------------------------------------------------
#if defined(__MINGW32__) || defined(__GNUC__)
  // Warnung: unused parameter 'argc'
  #pragma GCC diagnostic pop
#endif
//-----------------------------------------------------------------------------
#ifdef _MSC_VER
  // 'SUPER': Unreferenzierter formaler Parameter
  #pragma warning( default : 4100 )
#endif
//-----------------------------------------------------------------------------
